(* type t *)
type 'a t   = 'a cell Lazy.t
and 'a cell = Nil
            | Cons of ('a * 'a t)
(* fc : 'a Lazy.t -> 'a *)
let fc = Lazy.force
(* filter : ('a -> bool) -> 'a t -> 'a t *)
let rec filter p xs = lazy(match fc xs with
 | Nil        -> Nil
 | Cons(x,xs) -> if p x then Cons(x,filter p xs)
                        else fc(filter p xs)
)
(* take : int -> 'a t -> 'a list *)
let rec take n xs = if n < 1 then [] else match fc xs with
 | Nil        -> []
 | Cons(x,xs) -> x :: take (n-1) xs
(* from : int -> int t *)
let rec from n = lazy(Cons(n,from(n+1)))
(* sieve : int t -> int t *)
let rec sieve xs = lazy(match fc xs with
 | Nil        -> Nil
 | Cons(x,xs) ->
  Cons(x,sieve(filter (fun y -> y mod x <> 0) xs))
)
(* primes : int t *)
let primes = sieve(from 2)
(* *)
