(* type llist *)
type 'a cell = Nil
             | Cons of ('a * 'a llist)
and 'a llist = (unit -> 'a cell)
(* hd : 'a llist -> 'a *)
let hd xs = match xs() with
 | Nil       -> failwith "empty list"
 | Cons(x,_) -> x
(* from : int -> int llist *)
let rec from n = fun() -> Cons(n,from(n+1))
(* take : int -> int llist -> int list *)
let rec take n xs = if n < 1 then [] else match xs() with
 | Nil        -> []
 | Cons(x,xs) -> x :: take (n-1) xs
(* tl : 'a llist -> 'a llist *)
let tl xs = match xs() with
 | Nil        -> failwith "empty list"
 | Cons(_,xs) -> xs
(* zip2_with : ('a -> 'b -> 'c) -> 'a llist -> 'b llist -> 'c llist *)
let rec zip2_with f xs ys = fun() -> match (xs(),ys()) with
 | (Cons(x,xs),Cons(y,ys)) -> Cons(f x y,zip2_with f xs ys)
 | _                       -> Nil
(* fibs : int llist *)
let rec fibs() = Cons(0,fun() -> Cons(1,
 zip2_with (+) fibs (tl fibs)))
(* *)
